//Task: biathlon - O(n*logn)
//Author: Rusko Shikov


#include <cstdio>
#include <string.h>
#include <math.h>
#include <iostream>
using namespace std;

const int nmax=1000000;
const int maxbittree=2097152;       //          n 

int tinv[nmax+1];
int perm[nmax+1];

int bit_zeros_count[maxbittree];      //            
                                      // =  

int n;
int n2;                               //          ,    

void init()
{
    int i, p;
    scanf("%d",&n);
    for (i=1;i<=n;i++)
      scanf("%d",&tinv[i]);
    n2=log2(n);
    n2=1<<n2;
    if (n2<n) n2 = 2*n2;  
    p=n2;                               //           
                                        //    .
                                        //        .  ,   
                                        //      n2,       
                                        //   2 .      
                                        //         1 (     ).
    int uk=0,count=1;                                    
    while (p>=1)
    {
        for (i=1;i<=count;i++)
        {
            uk++; bit_zeros_count[uk]=p;
        }        
        count=2*count;p=p/2;
    }                                    
    memset(perm,0,sizeof(perm));  
}

void del_zero(int p)        //     p    , ..
                            //          
                            //   0        
                            //   .
{
    int j;
    j=n2+p-1;
    bit_zeros_count[j]=0;
    j=j/2;
    while (j>0)
    {
        bit_zeros_count[j]=bit_zeros_count[j]-1;
        j=j/2;  
    }
}

int find_zero_pos(int zeronum)
{
  int pos=1;          //   
  int count=0;
  while (pos<n2)
  {
    if ((count+bit_zeros_count[2*pos])>=zeronum)
      pos=2*pos;
    else
      {
        count=count+ bit_zeros_count[2*pos];
        pos=2*pos+1; 
      }    
  }
  return pos-n2+1;  
}

int main()
{
    int i,j;
    init();
    for (i=1;i<=n;i++)
    {
       j=find_zero_pos(tinv[i]+1);
       perm[j]=i;
       del_zero(j);  
    }
    
    for (i=1;i<=n;i++)
      printf("%d\n",perm[i]);
    
}