//Task: biathlon - O(n*logn^2)
//Author: Rusko Shikov

#include <cstdio>
#include <string.h>
#include <iostream>

using namespace std;

const int nmax=1000000;

int tinv[nmax+1];
int perm[nmax+1];
int bit_ones_sum[nmax+1];       //     (Fenwick) 
                                //         
                                //     [i,j] 
int n;

void input()
{
    int i;
    scanf("%d",&n);
    for (i=1;i<=n;i++)
      scanf("%d",&tinv[i]);
    memset(bit_ones_sum,0,sizeof(bit_ones_sum)); 
    memset(perm,0,sizeof(perm));  
}

void change_bit_ones_sum(int i)  // ,   1   bit_ones_sum
                                 // (  )
{
  int j;
  for (j=i;j<=n;j=j+(j&-j))
    bit_ones_sum[j]=bit_ones_sum[j]+1;     
}

int calc_ones_sum(int i)       // , ,    i 
{                              //    (    )
                               //    1  i
   int k;                           
   int si=0;                  
   for (k=i;k>0;k=k&(k-1))
     si=si+bit_ones_sum[k];
   return si;    
}

int bs(int vtinv)
{
    int beg, end, m, czero;
    beg=1; end=n;
    m=(beg+end)/2;
    czero=m-calc_ones_sum(m);
    while ((czero != vtinv) || (perm[m]>0))
    {
       if (czero>=vtinv) end=m-1;
       else beg=m+1;
       m=(beg+end)/2;
       czero= m-calc_ones_sum(m);
    }
    return m;
}
int main()
{
    int i,j;
    input();
    for (i=1;i<=n;i++)
    {
        j=bs(tinv[i]+1);
        perm[j]=i;
        change_bit_ones_sum(j);
    }
    
    for (i=1;i<=n;i++)
      printf("%d\n",perm[i]);
        
}